#include <exec/types.h>
#include <devices/audio.h>
#include <exec/memory.h>"
#include <dos/dos.h>
#include "all_protos.h"
#include <exec/interrupts.h>

#include <proto/exec.h>

#define CLOCK 3579545

#define KANALY	4

extern WORD OpcDz;

__asm mt_init(register __a0);
__asm mt_music();
__asm mt_end();

far extern UBYTE mt_counter,mt_SongPos,mt_spec,mt_specpat;
far extern UWORD mt_PatternPos;
far WORD mt_playing=0;

struct MsgPort *(replyPort[KANALY]);
struct IOAudio *(audioIOB[KANALY]);
static UBYTE allocmap[]={1,2,4,8,16,32,64,128};
far struct Interrupt musinterr=
	{ {0},0,&mt_music };


static WORD k_rezerw[3][]={{3,1,2,0},{3,0,2,1},{1,2,0,3}};

struct  gfx2 {
 	UWORD per,len;
 	APTR dane;  };

extern unsigned long _MemType;
APTR malloc_chip(ULONG bytes)
	{	APTR a; ULONG mt=_MemType;
		_MemType=MEMF_CHIP;
		a=malloc(bytes);
		_MemType=mt;
	return a;
	}
		

struct VHDR {
	ULONG OneShotHiSamples;
	ULONG RepeatHiSamples;
	ULONG SamplesPerHiCycle;
	UWORD SamplesPerSecond;
		};


ULONG chunk(BPTR file);

GoToPat(WORD p)
{
mt_SongPos=p;
mt_PatternPos=0;
mt_counter=0;
}

GoToPat2(WORD p)
{
if (mt_SongPos==p) return;
mt_SongPos=p;
mt_PatternPos=0;
mt_counter=0;
}

GoToPatDelay(WORD p)
{
mt_specpat=p;
mt_spec=1;
}

MusicOn(APTR muz,WORD pat)
{
	if (!muz) return;
	if (mt_playing) return;
	mt_init(muz);
	GoToPat(pat); mt_spec=0;
	AddIntServer(5,&musinterr);
	mt_playing=1;
}

MusicOff()
{
	if (!mt_playing) return;
	RemIntServer(5,&musinterr);
	mt_end();
	mt_playing=0;
}

Load8SVX(char *filnaz,struct gfx2 *gfx2)
{
BOOL niemanag=1,niemasamp=1;
ULONG dlug,naz;
struct VHDR naglowek;
int ok=0;
BPTR file;

if (file=Open(filnaz,MODE_OLDFILE))
	{
  	if (chunk(file)=='FORM')
	{
  	chunk(file);
  	if (chunk(file)=='8SVX')
	{

    while (niemanag | niemasamp)
      {
        naz=chunk(file);
		dlug=chunk(file);
        if (naz=='VHDR')
           {
            Read(file,&naglowek, sizeof(struct VHDR));
            Przeskocz(file,dlug-sizeof(struct VHDR));
            niemanag=0;
            } else 
        if (naz=='BODY')
            {
            if (niemanag) return(NULL);
	         if (gfx2->dane = malloc_chip(dlug,MEMF_CHIP))
			 {
  		     gfx2->len = dlug;
   /* samp->dlug = naglowek.OneShotHiSamples+naglowek.RepeatHiSamples; */
		 gfx2->per = CLOCK / naglowek.SamplesPerSecond;
            Read(file, gfx2->dane, dlug);
			ok=1;
			}
            niemasamp=0;
            }
        else
          Przeskocz(file,dlug);
	}
	}
	}
	Close(file);
	}	// else NO FILE
return ok;
}

ULONG chunk(BPTR file)
	{
	ULONG ch;
	Read(file,&ch,4);
	return(ch);
    }

Przeskocz(BPTR file,ULONG ile)
    {
      Seek(file,ile,OFFSET_CURRENT);
    }

InitAudio(int ile)
{
int i,mam=0;

	for (i=0;i<ile;i++)
	{
	replyPort[i] = (struct MsgPort *)CreatePort(NULL);
	if (audioIOB[i] = (struct IOAudio *)CreateExtIO(replyPort[i], sizeof(struct IOAudio)))
				{
			    audioIOB[i]->ioa_Request.io_Message.mn_Node.ln_Pri =  85;
			    audioIOB[i]->ioa_Data = allocmap+i;
			    audioIOB[i]->ioa_Length = 1;
			    if (OpenDevice(AUDIONAME, 0, audioIOB[i], 0))
					{DeleteExtIO(audioIOB[i]);
					audioIOB[i]=0;
					}
						else 
					{mam++;
					PutMsg(replyPort[i],audioIOB[i]);
					}
				}
		if (mam==ile) break;
	}
	return mam;
}

CloseAudio()
{
int i;
for (i=0;i<KANALY;i++)
			{
		if (audioIOB[i])
				{
				AbortIO(audioIOB[i]);
				while (GetMsg(replyPort[i]));			
				CloseDevice(audioIOB[i]);
			    DeleteExtIO(audioIOB[i]);
				audioIOB[i]=0;
				}
		if (replyPort[i])
				{
				DeletePort(replyPort[i]);
				replyPort[i]=0;
				}
			}
}

Play8SVX(struct gfx2* gfx2,WORD kan,WORD razy,WORD vol,WORD force)
// kan = 
//    0,1,2,3....  		-	konkretny kanal
//    K_DOW,K_LEW,K_PRA	-	dowolny,lewy,prawy
//
// force = 
//    0 - gdy wolny
//    1 - zawsze
//
// zwraca -1, gdy nie ma wolnego kanalu
// nr kanalu, gdy jest
{
WORD k,*tabkan,chan;
if (!(OpcDz&1)) return;
if (OpcDz==3) kan=3;
if (kan>=0) chan=kan; else
             { tabkan=&(k_rezerw[-kan-1][0]); k=0;
			  chan=tabkan[k]; }
nastkan:
				if (!GetMsg(replyPort[chan]))
					{
					// kanal pracuje wiec...
					if (force&&((kan>=0)||(k==KANALY-1)))
						{
						// natychmiast zwolnic !!!
						AbortIO(audioIOB[chan]);
						while (GetMsg(replyPort[chan]));
						}
						else 
						// szukamy nastepnego
						{
						if (( ++k>=KANALY)||(kan>=0)) return -1;
							else {chan=tabkan[k]; goto nastkan;}	

						}
					}		
				/* setup the audio I/O block to play sound */
				audioIOB[chan]->ioa_Request.io_Command = CMD_WRITE;
				audioIOB[chan]->ioa_Request.io_Flags = ADIOF_PERVOL;
				audioIOB[chan]->ioa_Data = gfx2->dane;
				audioIOB[chan]->ioa_Length = gfx2->len;
				audioIOB[chan]->ioa_Period = gfx2->per;
				audioIOB[chan]->ioa_Volume = vol;
				audioIOB[chan]->ioa_Cycles = razy;
				/* start the sound */
				BeginIO(audioIOB[chan]);
				return chan;
}

SetVol(WORD kan,WORD vol)
{
if (OpcDz!=1) return;
*(WORD *)(0xdff0a8+((kan&3)<<4))=vol;
}

SetPeriod(WORD kan,WORD per)
{
if (OpcDz!=1) return;
*(WORD *)(0xdff0a6+((kan&3)<<4))=per;
}

KanOff(WORD kan)
{
if (!(OpcDz&1)) return;
AbortIO(audioIOB[kan]);
}

Free8SVX(struct gfx2 *sfx)
{
	if (sfx->dane) {free(sfx->dane); sfx->dane=0;}
}
